SystemOrganization addCategory: #'Spec-Tools-ChangeSorter'!
SystemOrganization addCategory: #'Spec-Tools-Monticello'!
SystemOrganization addCategory: #'Spec-Tools-Senders'!

ComposableModel subclass: #ChangeSorterApplication
	instanceVariableNames: 'model changesListModel classesListModel methodsListModel textModel prettyPrint showDiff title prettyButton diffButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterApplication commentStamp: '<historical>' prior: 0!
A ChangeSorterApplication is spec version of the dual sorter!

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/17/2012 14:18'!
internSpec
	<spec>
	^ {#Panel.
			#useProportionalLayout.
			#add:.				{	self topSpec.
										#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0@0 corner: 1@0.33). nil}}.
			#add:. 		{{	#model. 	#methodsListModel.	#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0@0.33 corner: 1@0.66). nil}}.
			#addMorph:. 		{{	#model. 	#textModel.	#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0@0.66 corner: 1@1). nil}}.
			#addPaneSplitters.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/17/2012 14:22'!
topSpec

	^ {#Panel.
			#useProportionalLayout.
			#add:. 		{{	#model. 	#changesListModel.	#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0@0 corner: 0.5@1). nil}}.
			#add:. 		{{	#model. 	#classesListModel.	#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0.5@0 corner: 1@1). nil}}.
			#addPaneSplitters.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
addPreamble

	self model addPreambleTo: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
browseChangeSet
	"Open a message list browser on methods in the current change set"

	| messages |
	messages := self selectedChangeSet changedMessageList select: [ :each | each isValid].	
	Smalltalk tools  messageList
		openMessageList: messages 
		name: 'Methods in Change Set ', self selectedChangeSet name 
		autoSelect: ''! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseImplementorsOfMessages

	self model browseMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self selectedClass ifNotNil:
		[:myClass | Smalltalk tools browser fullOnClass: myClass selector: self selectedSelector ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseSendersOfMessages

	self model browseSendersOfMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
browseVersions
	"Create and schedule a changelist browser on the versions of the 
	selected message."
	
	self selectedClass ifNotNil: [:class |
		self selectedSelector ifNotNil: [:selector || method |
			method := class methodDict 
								at: selector 
								ifAbsent: [ ^ self inform: 'Sorry, only actual methods have retrievable versions.' ].
			self model browseVersionsFrom: method ]]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu1: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	aMenu 
		title: 'Change Set';
		target: self.
		
	self selectedChangeSet
		ifNotNil:[
			aMenu
				add: 'Make changes go to me (m)'
				action: #setCurrentChangeSet;
				addLine;
				add: 'New change set... (n)'
				action: #newSet ].
	aMenu
		add: 'Find...(f)' 
		action: #findChangeSet.

	self selectedChangeSet
		ifNotNil:[
			aMenu
				addLine;
				add: 'Rename change set (r)'
				action: #rename;
				add: 'File out (o)'
				action: #fileOut;
				add: 'Browse methods (b)' 
				action: #browseChangeSet;
				add: 'Browse change set (B)'
				action: #openChangeSetBrowser;
				addLine ]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu2: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	| cs |
	
	cs := self selectedChangeSet.
	self selectedChangeSet
		ifNotNil:[
			(cs notNil and: [ cs hasPreamble ])
				ifTrue: [
							aMenu add: 'Edit preamble (p)' action: #addPreamble.
							aMenu add: 'Remove preamble' action: #removePreamble	]
				ifFalse: [	aMenu add: 'Add preamble (p)' action: #addPreamble			].
			(cs notNil and: [ cs hasPostscript ])
				ifTrue: [	
							aMenu add: 'Edit postscript...' action: #editPostscript.
							aMenu add: 'Remove postscript' action: #removePostscript	]
				ifFalse: [	aMenu add: 'Add postscript...' action: #editPostscript			].

			aMenu addLine.

			aMenu add: 'Destroy change set (x)' action: #remove ].! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	self changeSetMenu1: aMenu shifted: isShifted.
	self changeSetMenu2: aMenu shifted: isShifted.
	
	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
changeSetShortcuts: event from: aMorph

	self selectedChangeSet
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseChangeSet ].
			event keyString = '<Cmd-B>' 		ifTrue: [ ^ self openChangeSetBrowser ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self setCurrentChangeSet ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self newSet ].
			event keyString = '<Cmd-o>' 		ifTrue: [ ^ self fileOut ].
			event keyString = '<Cmd-r>' 		ifTrue: [ ^ self rename ].
			event keyString = '<Cmd-p>' 		ifTrue: [ ^ self addPreamble ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self remove ]].
			
	event keyString = '<Cmd-f>' 				ifTrue: [ ^ self findChangeSet ].
		! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changeSets

	^ self changesListModel getList! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changesListModel

	^ changesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesMenu: aBlock

	changesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
changesShortcuts: aBlock

	changesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
classMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	self selectedClass ifNil: [ ^ nil ].
	aMenu title: 'Class list'.

	aMenu target: self.
	aMenu addList: #(
			-
			('Delete class from change set (d)'		forgetClass)
			('Remove class from system (x)'		removeClass)
			-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutClass)).

	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
classShortcuts: event from: aMorph

	self selectedClass
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetClass ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeClass ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
classesListModel

	^ classesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesMenu: aBlock

	classesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
classesShortcuts: aBlock

	classesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
currentText

	 ^ textModel getText! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
defaultTitle
	
	^  'Change Sorter'! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
editPostscript
	
	self selectedChangeSet editPostscript! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
fileOut

	self selectedChangeSet fileOut! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
fileOutClass

	self model fileOutClass: self selectedClass from: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedSelector ifNotNil: [:selector |
		Cursor write showWhile:
			[ self model fileOutSelector: selector from: self selectedClass ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
findChangeSet

	| set |
	set := self model findChangeSetIn: self changeSets.
	changesListModel setSelectedItem: set.! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
forceChangesListRefresh
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
forgetClass
	"Remove all mention of this class from the changeSet"

	self okToChange ifFalse: [^ self].
	self selectedClass ifNotNil: [:class |
		self model removeClass: class from: self selectedChangeSet.
		self setSelectedChangeSet: self selectedChangeSet ].
! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
forgetMessage

	self okToChange ifFalse: [^ self].
	self selectedSelector ifNotNil: [:selector | 
		self model 
			forgetSelector: selector 
			inClass: self selectedClass 
			fromChangeSet: self selectedChangeSet.
		self updateClassesList.
		self setSelectedClassIndex: self selectedClassIndex ]! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/17/2012 14:14'!
initialize
	"Initialization code for ChangeSorterApplication"

	super initialize.

	self instantiateWidgets.
	self setFocus.
	
	prettyPrint := false.
	showDiff := false.
	
	model := ChangeSorterModel new.
	title := self defaultTitle.
	
	self bindings: MorphicBindingsWithSplitters new.	

	changesListModel wrappingBlock: [:item | item name ].
	changesListModel items: self model allChanges.
	
	self registerChangeActions.
	self registerClassActions.
	self registerSelectorActions.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateChangeSetModel
	
	changesListModel := self instantiate: ListComposableModel.
	changesListModel menu: [:aMenu :shifted | self changeSetMenu: aMenu shifted: shifted  ].
	changesListModel shortcuts: [:event :source | self changeSetShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateClassModel
	
	classesListModel := self instantiate: ListComposableModel.
	classesListModel menu: [:aMenu :shifted | self classMenu: aMenu shifted: shifted ].
	classesListModel shortcuts: [:event :source | self classShortcuts: event from: source ].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateMethodModel

	methodsListModel := self instantiate: ListComposableModel.
	methodsListModel menu: [:menu :shifted | self messageMenu: menu shifted: shifted ].
	methodsListModel shortcuts: [:event :source | self methodShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateRadioButtons

	prettyButton := self instantiate: CheckBoxModel.
	diffButton := self instantiate: CheckBoxModel.
	
	prettyButton activationAction: [ 
		prettyPrint := true.
		self updateTextContents ].
	prettyButton desactivationAction: [ 
		prettyPrint := false.
		self updateTextContents  ].
	diffButton activationAction: [ 
		showDiff := true.
		self updateTextContents ].
	diffButton desactivationAction: [ 
		showDiff := false.
		self updateTextContents  ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateTextModel

	textModel := self instantiate: TextModel.
	textModel aboutToStyle: true.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
instantiateWidgets
	
	self instantiateChangeSetModel.
	self instantiateClassModel.
	self instantiateMethodModel.
	self instantiateTextModel.
	
	self instantiateRadioButtons! !

!ChangeSorterApplication methodsFor: 'menu' stamp: ''!
messageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	self selectedSelector ifNil: [ ^ nil ].	
	aMenu title: 'Message list'.
	aMenu target: self.

	aMenu addList: #(
			('Delete method from changeSet (d)'	forgetMessage)
			('Remove method from system (x)'		removeMessage)
				-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutMessage)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'				browseImplementorsOfMessages)
			('Versions (v)'							browseVersions)).
	^ aMenu
! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
methodShortcuts: event from: aMorph

	self selectedSelector
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetMessage ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self browseImplementorsOfMessages ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self browseSendersOfMessages ].
			event keyString = '<Cmd-v>' 		ifTrue: [ ^ self browseVersions ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeMessage ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
methodsListModel

	^ methodsListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
methodsShortcuts: aBlock

	methodsListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
newSet

	| aSet |
	self okToChange ifFalse: [ ^ self ].
	aSet := self model createNewSet.
	aSet ifNotNil:
		[	self updateChangesList.
			changesListModel setSelectedItem: aSet ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
openChangeSetBrowser
	| cs env |
	
	cs := self selectedChangeSet.
	cs ifNil: [ ^ nil ].
	
	env := RBBrowserEnvironment new forClasses: cs changedClasses.

	Smalltalk tools browser fullOnEnvironment: env! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
registerChangeActions
	
	changesListModel
		whenSelectedItemChanges: [:change | 
			classesListModel resetSelection.
			self updateTextContents.
			change 
				ifNil: [
					classesListModel items: {}.
					methodsListModel items: {}.
					self title: self defaultTitle ]
				ifNotNil: [
					classesListModel items: (change changedClasses sort: [:a :b | a name < b name ]).
					self title: change name ]].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
registerClassActions
	
	classesListModel whenSelectedItemChanges: [:class | 
		methodsListModel resetSelection.
		self updateTextContents.
		textModel behavior: class.
		textModel aboutToStyle: false.
		class 
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [ methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort ]].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
registerSelectorActions

	methodsListModel whenSelectedItemChanges: [:selector |
		self updateTextContents ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self model removeChangeSet: self selectedChangeSet prompting: true.
	self updateChangesList.
	changesListModel resetSelection! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	(self model removeClass: self selectedClass)
		ifTrue: [ self setSelectedChangeSet: self selectedChangeSet ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: ''!
removeMessage
	"Remove the selected message from the system."
	
	self okToChange
		ifFalse: [^ self].
	self selectedSelector
		ifNotNil: [:selector |
				(self model removeMethod: selector inClass: self selectedClass)
					ifTrue: [ self updateMessagesList ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePostscript

	self model removePostscriptFrom: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
removePreamble

	self selectedChangeSet removePreamble.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
rename

	| set |
	set := self model rename: self selectedChangeSet.
	
	changesListModel 
		updateList;
		setSelectedItem: set! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSet

	 ^ changesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedChangeSetIndex

	 ^ changesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClass

	 ^ classesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedClassIndex

	 ^ classesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectedSelector

	 ^ methodsListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
selectorsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
setCurrentChangeSet

	self model setCurrentChangeSet: self selectedChangeSet.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: changesListModel;
		add: classesListModel;
		add: methodsListModel;
		add: textModel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSet: aChangeSet

	 ^ changesListModel setSelectedItem: aChangeSet! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedChangeSetIndex: anIndex

	 ^ changesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClass: aClass

	 ^ classesListModel setSelectedItem: aClass! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
setSelectedClassIndex: anIndex

	 ^ classesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: ''!
textModel

	^ textModel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
title

	^ title! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
title: aTitle

	title := aTitle.
	window ifNotNil: [ window title: aTitle ]! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateChangesList
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesList
	| sel |
	sel := self selectedClass.
	
	self selectedChangeSet
			ifNil: [ classesListModel items: {} ]
			ifNotNil: [:change |	classesListModel items: (change changedClasses sort: [:a :b | a name < b name ])].
				
	classesListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateClassesListAndMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self updateClassesList.
	methodsListModel setSelectedItem: sel.
	self updateMessagesList.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: ''!
updateMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self selectedClass
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [:class | methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort].
				
	methodsListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'private' stamp: ''!
updateTextContents

	| text |
	text :=  (self model 
				setContentsOfChangeSet: self selectedChangeSet
				forClass: self selectedClass
				andSelector: self selectedSelector
				prettyPrint: prettyPrint
				showDiff: showDiff).
	({'Method was added, but cannot be found!!'. 'Added then removed (see versions)'. 'Method has been removed (see versions)'} includes: text)
		ifTrue: [ textModel aboutToStyle: false ]
		ifFalse: [ textModel aboutToStyle: true ] .
	textModel text: text.! !

!ChangeSorterApplication methodsFor: 'protocol-events' stamp: ''!
whenChangesListChanges: aBlock

	changesListModel whenListChanges: aBlock! !

ComposableModel subclass: #DualChangeSorterApplication
	instanceVariableNames: 'model changeSorterLeft changeSorterRight isRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!DualChangeSorterApplication commentStamp: '<historical>' prior: 0!
A DualChangeSorterApplication is a dual change sorter based on psec!

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/17/2012 14:20'!
internSpec
	<spec>
	^ {#Panel.
			#useProportionalLayout.
			#add:.	{{	#model.	#changeSorterLeft.			#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0@0 corner: 0.5@1). nil}}.
			#add:.	{{	#model.	#changeSorterRight.		#internSpec	}.
									#layout:.  {#LayoutFrame.
														#fractions:offsets:. (0.5@0 corner: 1@1). nil}}.
			#addPaneSplitters.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!DualChangeSorterApplication class methodsFor: 'specs' stamp: ''!
title

	^'Dual Change Sorter'! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterLeft

	^ changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
changeSorterRight

	^ changeSorterRight! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
checkThatSidesDiffer: escapeBlock
	"If the change sets on both sides of the dual sorter are the same, put up an error message and escape via escapeBlock, else proceed happily"

	changeSorterLeft selectedChangeSet == changeSorterRight selectedChangeSet
		ifTrue:
			[self inform: 
'This command requires that the
change sets selected on the two
sides of the change sorter *not*
be the same.'.
			^ escapeBlock value]
! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
copyAllToLeft

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterRight selectedChangeSet) to: (changeSorterLeft selectedChangeSet).
	changeSorterLeft updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
copyAllToRight

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterLeft selectedChangeSet) to: (changeSorterRight selectedChangeSet).
	changeSorterRight updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
copyClassToLeft
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterRight selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterLeft selectedChangeSet.
	
	self model copyClass: changeSorterRight selectedClass from: changeSorterRight selectedChangeSet to: otherChangeSet.
	
	changeSorterLeft setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
copyClassToRight
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterLeft selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterRight selectedChangeSet.
	
	self model copyClass: changeSorterLeft selectedClass from: changeSorterLeft selectedChangeSet to: otherChangeSet.
	
	changeSorterRight setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: ''!
copyMethodToLeft
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterLeft selectedChangeSet.
	
	changeSorterRight selectedSelector ifNotNil: [:selector || class |
		class := changeSorterRight selectedClass.
		
		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterRight selectedChangeSet 
			to: other.
			
		changeSorterLeft updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: ''!
copyMethodToRight
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterRight selectedChangeSet.
	
	changeSorterLeft selectedSelector ifNotNil: [:selector || class |
		class := changeSorterLeft selectedClass.

		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterLeft selectedChangeSet 
			to: other.		
			
		changeSorterRight updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/17/2012 14:10'!
initialize
	"Initialization code for DualChangeSorterApplication"

	super initialize.

	changeSorterLeft := self instantiate: ChangeSorterApplication.
	changeSorterRight := self instantiate: ChangeSorterApplication.
	model := ChangeSorterModel new.
	isRefreshing := false.
	
	self bindings: MorphicBindingsWithSplitters new.
	
	changeSorterLeft 	whenChangesListChanges: [ self leftChangeSetRefreshed 	].
	changeSorterRight	whenChangesListChanges: [ self rightChangeSetRefreshed	].
			
	self menusRegistration.
	self shortcutsRegistration.
	self setFocusOrder! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 5/11/2012 16:41'!
leftChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterRight updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
leftChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToRight ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractRight ].
	
	^ changeSorterLeft changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
leftChangesMenu: menu shifted: shifted

	changeSorterLeft changeSetMenu1: menu shifted: shifted.
	
	changeSorterLeft selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to right change set (c)' 
				target: self
				action: #copyAllToRight.
			menu 
				add: 'Submerge into right change set' 
				target: self
				action: #submergeIntoRight.
			menu 
				add: 'Subtract right change set (-)'
				target: self
				action: #subtractRight.
			menu addLine] .
	
	changeSorterLeft changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
leftClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterLeft selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to right change set'			copyClassToRight)	
			('Move class to right change set'			moveClassToRight)
			-
			).
						
	changeSorterLeft classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
leftMenusRegistration.
	
	changeSorterLeft changesMenu: [:menu :shifted | self leftChangesMenu: menu shifted: shifted ].
	changeSorterLeft classesMenu: [:menu :shifted | self leftClassMenu: menu shifted: shifted ].
	changeSorterLeft methodsMenu: [:menu :shifted | self leftMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
leftMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterLeft selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to  right change set'			copyMethodToRight)
		('Move method to  right change set'			moveMethodToRight)
		-
		).
					
	changeSorterLeft messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
leftShortcutsRegistration.
	
	changeSorterLeft changesShortcuts: [:event :source | self leftChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
menusRegistration

	self leftMenusRegistration.
	self rightMenusRegistration.! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: ''!
model

	^ model! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
moveClassToLeft

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterRight selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToLeft.
	changeSorterRight forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: ''!
moveClassToRight

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterLeft selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToRight.
	changeSorterLeft forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: ''!
moveMethodToLeft

	self copyMethodToLeft.
	changeSorterRight forgetMessage.
	changeSorterRight updateClassesListAndMessagesList.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: ''!
moveMethodToRight

	self copyMethodToRight.
	changeSorterLeft forgetMessage.! !

!DualChangeSorterApplication methodsFor: 'event' stamp: ''!
rightChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterLeft updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: ''!
rightChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToLeft ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractLeft ].
	
	^ changeSorterRight changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
rightChangesMenu: menu shifted: shifted

	changeSorterRight changeSetMenu1: menu shifted: shifted.
	
	changeSorterRight selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to left change set(c)' 
				target: self
				action: #copyAllToLeft.
			menu 
				add: 'Submerge into left change set' 
				target: self
				action: #submergeIntoLeft.
			menu 
				add: 'Subtract left change set (-)'
				target: self
				action: #subtractLeft.
			menu addLine] .
	
	changeSorterRight changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
rightClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterRight selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to left change set'			copyClassToLeft)	
			('Move class to left change set'			moveClassToLeft)
			-
			).
						
	changeSorterRight classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
rightMenusRegistration
	
	changeSorterRight changesMenu: [:menu :shifted | self rightChangesMenu: menu shifted: shifted ].
	changeSorterRight classesMenu: [:menu :shifted | self rightClassMenu: menu shifted: shifted ].
	changeSorterRight methodsMenu: [:menu :shifted | self rightMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: ''!
rightMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterRight selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to left change set'			copyMethodToLeft)
		('Move method to left change set'			moveMethodToLeft)
		-
		).
					
	changeSorterRight messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
rightShortcutsRegistration.
	
	changeSorterRight changesShortcuts: [:event :source | self rightChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: changeSorterLeft;
		add: changeSorterRight.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: ''!
shortcutsRegistration

	self leftShortcutsRegistration! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
submergeIntoLeft
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| rightChangeSet other index |

	rightChangeSet := changeSorterRight selectedChangeSet.
	other := changeSorterLeft selectedChangeSet.
	index := changeSorterRight selectedChangeSetIndex.

	(self model submerge: rightChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterRight updateChangesList.
	changeSorterRight setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
submergeIntoRight
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| leftChangeSet other index |

	leftChangeSet := changeSorterLeft selectedChangeSet.
	other := changeSorterRight selectedChangeSet.
	index := changeSorterLeft selectedChangeSetIndex.

	(self model submerge: leftChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterLeft updateChangesList.
	changeSorterLeft setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
subtractLeft
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterRight selectedChangeSet.
	destination := changeSorterLeft selectedChangeSet.
	
	self checkThatSidesDiffer: [^ self].
	
	self model substractFrom: source to: destination.
	
	changeSorterRight setSelectedChangeSet: source.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: ''!
subtractRight
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterLeft selectedChangeSet.
	destination := changeSorterRight selectedChangeSet.

	self checkThatSidesDiffer: [^ self].

	self model substractFrom: source to: destination.

	changeSorterLeft setSelectedChangeSet: source.! !

ComposableModel subclass: #MessageBrowser
	instanceVariableNames: 'listModel textConverter textModel toolbarModel maxClassSize window refreshingBlockHolder cachedHierarchy wrapper searchedStringHolder titleHolder model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!MessageBrowser commentStamp: '<historical>' prior: 0!
A MessageBrowser is a UI to browse a list of method, regardless of what they could be.

example: 

MessageBrowser new
	openWithSpec;
	messages: (SystemNavigation default allSendersOf: #at:)
	yourself!

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseImplementors: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForImplementorsOf: aSymbol;
		messages: aCollection;
		title: aName;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseMessages: aCollection refreshingBlock: aBlock named: anObject

	^ self new
		refreshingBlock: aBlock;
		messages: aCollection;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
browseSenders: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForSendersOf: aSymbol;
		messages: aCollection;
		title: aName;
		autoSelect: aSymbol;
		yourself! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/23/2012 17:11'!
internSpec
	<spec>
	| delta |
	delta := 13.
	^{ #Panel.
			#useProportionalLayout.
			#add:.	{{#model. #listModel. #internSpec}. 
									#layout:. 	{#FrameLayout.
																#fractions:offsets:.	 (0@0 corner: 1@0.5).		(0@0 corner: 0@(delta negated)). 		}}.
			#add:.	{{#model. #toolbarModel. #internSpec.}.
									#layout:. 	{#FrameLayout.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(delta negated) corner: 0@delta). 	}}.															
			#add:.	{{#model. #textModel. #internSpec.}.
									#layout:. 	{#FrameLayout.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@delta corner: 0@0). }}.
			#addSplitters.
			#vSpaceFill.
			#hSpaceFill.}.! !

!MessageBrowser class methodsFor: 'instance creation' stamp: ''!
on: aList named: aString autoSelect: aSelector

	^ self new
		messages: aList;
		title: aString;
		autoSelect: aSelector;
		yourself! !

!MessageBrowser class methodsFor: 'tool registration' stamp: ''!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compitibility "

	| title |
	aString last = $]
			ifTrue: [ title := aString substrings allButLast joinUsing: ' ' ]
			ifFalse: [ title := aString ].
			
	(aString beginsWith: 'Senders')
		ifTrue: [ ^ (self browseSenders: messageList of: aSelector named: title) openWithSpec ].
	
	(aString beginsWith: 'Implementors')
		ifTrue: [ ^ (self browseImplementors: messageList of: aSelector named: title) openWithSpec ].
	
	^ (self on: messageList named: title autoSelect: aSelector) openWithSpec! !

!MessageBrowser class methodsFor: 'tool registration' stamp: ''!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	"registry register: self as: #messageList"! !

!MessageBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Message Browser'! !

!MessageBrowser methodsFor: 'private' stamp: ''!
accept: text notifying: notifyer

	listModel selectedItem
		ifNotNil: [:message | message methodClass compile: text notifying: notifyer ]! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
autoSelect: aSelector

	textModel readSelectionBlock: [:text | self searchedString: aSelector in: text ]! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
buildHierarchyForMessages: messages
	| result classes |
	
	result := IdentityDictionary new.
	classes := (messages collect: #methodClass) asSet.
	messages do: [:message || level class |
		class := message methodClass.
		level := OrderedCollection new.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level addFirst: superClass ]].
		level addLast: class.
		level addLast: message selector.
		result at: message put: level ].
	^ result! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
cacheHierarchyForClasses: aCollection

	cachedHierarchy := self buildHierarchyForMessages: aCollection.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 5/7/2012 13:05'!
eventRegistration
	
	listModel whenSelectedItemChanges: [:item |
			toolbarModel method: item.
			textModel behavior: (item ifNil: [ nil ] ifNotNil: [ item methodClass ]).
			textModel text: (textConverter method: item; getText)].
		
	listModel whenListChanges: [ self setTitle ].
		
	titleHolder
		whenChangedDo: [ self setTitle ]! !

!MessageBrowser methodsFor: 'private' stamp: ''!
highlightSearchedString: string
	
	| searchedString interval firstIndex |
	searchedString := searchedStringHolder contents.
	searchedString ifNil: [ ^ 0 to: 0 ].

	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := string findString: searchedString.
					interval := firstIndex to: (firstIndex+searchedString size-1)]
				ifFalse: [| lastIndex |
					firstIndex := string findString: list first,':'.
					lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
					interval := firstIndex to: (lastIndex + list last size)]]
		ifFalse: [
			" unary selector "
			firstIndex := string findString: searchedString.
			interval := firstIndex to: (firstIndex+searchedString size-1)].
	^ interval! !

!MessageBrowser methodsFor: 'private' stamp: ''!
initialExtent

	^ (500 min: (World extent x)) @ (550 min: (World extent y))! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/17/2012 14:49'!
initialize
	"Initialization code for MessageBrowser"

	super initialize.
	listModel := self instantiate: MultiColumnListModel.
	textConverter := SourceMethodConverter new.
	textModel := self instantiate: TextModel.
	textModel aboutToStyle: true.
	toolbarModel := self instantiate: MethodToolbar.
	maxClassSize = nil.
	refreshingBlockHolder := [ :item | false ] asValueHolder.
	searchedStringHolder := '' asValueHolder.
	titleHolder := super title asValueHolder.
	model := AbstractTool new.
	listModel wrappingBlock: [ :item | self wrapItem: item ].
	
	self
		setListMenu;
		setListShortcuts;
		eventRegistration;
		initializeDropList;
		registerToAnnouncements;
		setFocus.
		
	textModel action: [ :text :notifyer | self accept: text notifying: notifyer ].
	self bindings: MorphicBindingsWithSplitters new.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/20/2012 15:25'!
initializeDropList

	| item1 item2 item3 item4 |
	item1 := DropListItem 
					named: 'Source' 
					do: [ self textConverter: SourceMethodConverter new ].
	item2 := DropListItem 
					named: 'Byte Code' 
					do: [ self textConverter: ByteCodeMethodConverter new ].
	item3 := DropListItem
					named: 'Decompile' 
					do: [ self textConverter: DecompileMethodConverter new ].
	item4 := DropListItem
					named: 'Time stamp' 
					do: [ self textConverter: TimeStampMethodConverter new ].
	toolbarModel setDropListItems: {item1. item2. item3. item4}! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
listModel
	
	^ listModel! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
listShortcutsFor: event form: source message: method

	event keyString = '<Cmd-b>'			ifTrue: [ ^ Smalltalk tools browser fullOnClass: method methodClass selector: method selector ].
	event keyString = '<Cmd-i>'			ifTrue: [ ^ method inspect ].
	event keyString = '<Cmd-x>'			ifTrue: [ ^ model removeMethod: method inClass: method methodClass ].
	event keyString = '<Cmd-n>'			ifTrue: [ ^ model browseSendersOfMessagesFrom: method selector ].
	event keyString = '<Cmd-m>'			ifTrue: [ ^ model browseMessagesFrom: method selector ].
	event keyString = '<Cmd-N>'			ifTrue: [ ^ model browseClassRefsOf: method methodClass ].
	event keyString = '<Cmd-v>'			ifTrue: [ ^ model browseVersionsFrom: method ].
	^ false! !

!MessageBrowser methodsFor: 'private' stamp: ''!
maxClassSize

	^ maxClassSize ifNil:[| elt stm |
			elt := (listModel getList detectMax: [:e | e methodClass name size + (cachedHierarchy at: e) size]).
			stm := String streamContents: [:t | 
				3 to: (cachedHierarchy at: elt) size do: [:i | t << '    '].
				t << elt methodClass name ].
			maxClassSize := StandardFonts listFont widthOfString: stm ].
! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/7/2012 13:17'!
messages: aCollection

	self cacheHierarchyForClasses: aCollection.
	listModel items: (cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]) asOrderedCollection.
	listModel listSize > 1
		ifTrue: [ 
			listModel setSelectedIndex: 1 ].! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 5/9/2012 13:04'!
methodAdded: anAnnouncement
	| item |	
		
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].
	[ 	| sel text boolean |
		boolean := textModel hasUnacceptedEdits.
		boolean ifTrue: [ text := textModel pendingText ].
		sel := listModel selectedItem.
		self messages: (listModel listItems add: item; yourself).
		listModel setSelectedItem: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	] fork! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 5/9/2012 14:06'!
methodModified: anAnnouncement
	| item oldItem sel |
	
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	oldItem := anAnnouncement oldItem.
	sel := listModel selectedItem.
	sel ifNil: [ ^ self ].
	(sel notNil and: [(sel methodClass = oldItem methodClass and: [ sel selector = oldItem selector ])]) ifFalse: [ ^ self ].
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].	
	[	| text  list edits |
		edits := textModel hasUnacceptedEdits.
		edits
			ifTrue: [ text := textModel pendingText ].
		list := listModel listItems 
				remove: sel ifAbsent: [];
				add: item;
				yourself. 
		self messages: list.
		listModel setSelectedItem: item.
		edits
			ifTrue: [ 
				textModel pendingText: text.
				textModel changed: #codeChangedElsewhere ].
		] fork! !

!MessageBrowser methodsFor: 'announcements' stamp: ''!
methodRecategorized: aMethod! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 5/9/2012 13:05'!
methodRemoved: anAnnouncement
	| item |
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self)
		ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	[ 	| sel itm text boolean removed |
		sel := listModel selectedIndex.
		itm := listModel selectedItem.
		text := textModel pendingText.
		boolean := true.
		(itm notNil and: [(itm methodClass = item methodClass and: [ itm selector = item selector ])])
			ifTrue: [ boolean := textModel okToChange ].
		self messages: (listModel listItems remove: item ifAbsent: [ nil ]; yourself).
		listModel setSelectedIndex: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	] fork! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
openWithSpec

	window := super openWithSpec.
	self setTitle.
	textModel text: textModel getText.
	^ window! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
refreshingBlock: aBlock

	refreshingBlockHolder contents: aBlock! !

!MessageBrowser methodsFor: 'announcements-registration' stamp: ''!
registerToAnnouncements

	SystemAnnouncer announcer weak		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self! !

!MessageBrowser methodsFor: 'text selection' stamp: ''!
searchedString: searchedString in: aString
	| string interval firstIndex |
	
	searchedString ifNil: [ ^ 0 to: 0 ].
	aString isEmptyOrNil ifTrue: [ ^0 to: 0 ].
	string := aString asString.
	interval := 0 to: 0.
	
	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: searchedString startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]]
				ifFalse: [| lastIndex |
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: list first,':' startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ 
									lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
									interval := firstIndex to: (lastIndex + list last size)]]]]
		ifFalse: [
			" unary selector "
			firstIndex := 1.
			[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
				whileTrue: [
					firstIndex := string findString: searchedString startingAt: firstIndex +1.
					firstIndex isZero
						ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]].
	^ interval! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
selectedMessage: aMessage

	listModel setSelectedItem: aMessage.! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setFocus

	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListMenu

	listModel menu: [:menu || message |
		message := self selectedMessage.
		menu
			add: 'Browse full... (b)'
			target: Smalltalk tools browser
			selector: #fullOnClass:selector:
			argumentList: {message methodClass. message selector };
			add: 'Inspect method... (i)'
			target: message
			selector: #inspect;
			addLine;
			add: 'Remove method... (x)'
			target: model
			selector: #removeMethod:inClass:
			argumentList: {message. message methodClass.};
			add: 'Toggle Breakpoint'
			target: model
			selector: #toggleBreakOnEntryIn:
			argument: message;
			addLine;
			add: 'Senders of... (n)'
			target: model
			selector: #browseSendersOfMessagesFrom:
			argument: message selector;
			add: 'Implementors of... (m)'
			target: model
			selector: #browseMessagesFrom:
			argument: message selector ;
			add: 'Users of... (N)'
			target: model
			selector: #browseClassRefsOf:
			argument: message methodClass;
			add: 'Versions... (v)'
			target: model
			selector: #browseVersionsFrom:
			argument: message.
		menu]! !

!MessageBrowser methodsFor: 'initialization' stamp: ''!
setListShortcuts

	listModel shortcuts: [:event :source || message |
		message := self selectedMessage.
		self listShortcutsFor: event form: source message: message ]! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForImplementorsOf: aSelector

	self refreshingBlock: [:message | message selector = aSelector ].! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
setRefreshingBlockForSendersOf: aSelector
	| specialFlag specialByte |
	
	specialFlag := Smalltalk 
				hasSpecialSelector: aSelector
				ifTrueSetByte: [ :b | specialByte := b ].

	self refreshingBlock: [:method | (method refersToLiteral: aSelector) or: [ specialFlag and: [ method scanFor: specialByte ]]]! !

!MessageBrowser methodsFor: 'private' stamp: ''!
setTitle
		
	window ifNotNil: [ window title: self title , ' [' , listModel listSize printString , ']']! !

!MessageBrowser methodsFor: 'testing' stamp: ''!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
textConverter
	
	^ textConverter! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2012 14:16'!
textConverter: aTextConverter

	textConverter := aTextConverter method: textConverter method.
	textModel aboutToStyle: textConverter shouldShout .
	textModel text: textConverter getText.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
textModel
	
	^ textModel! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
title

	^ titleHolder contents! !

!MessageBrowser methodsFor: 'protocol' stamp: ''!
title: aString

	titleHolder contents: aString.! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel
	
	^ toolbarModel! !

!MessageBrowser methodsFor: 'accessing' stamp: ''!
window
	
	^ window! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/7/2012 22:34'!
wrapItem: anItem
	| s |
	
	s :=String streamContents: [:t | 
		3 to: (cachedHierarchy at: anItem) size do: [:i | t << '    '].
		t << anItem methodClass name<< ' ('<< anItem category <<')'].
	
	^ {s. anItem selector}.! !

ComposableModel subclass: #MonticelloRepositoryBrowser
	instanceVariableNames: 'repositories workingCopies order'
	classVariableNames: 'Order'
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!MonticelloRepositoryBrowser commentStamp: '<historical>' prior: 0!
MonticelloRepositoryBrowser example!

!MonticelloRepositoryBrowser class methodsFor: 'example' stamp: 'StephaneDucasse 4/17/2012 19:11'!
example
	"self example"
	
	self new 
		openWithSpec ; 
		workingCopies: (MCWorkingCopy allManagers)! !

!MonticelloRepositoryBrowser class methodsFor: 'spec' stamp: 'StephaneDucasse 4/17/2012 18:05'!
internSpec

	^ {
		#Panel . 
			#useProportionalLayout .
			#add: . {{#model . #workingCopies . #internSpec} . 
					#layout: . { #FrameLayout . #fractions:offsets: . 0@0 corner: 0.5@1 . 0@0 corner: 0@0} 
					} . 
			#add: . {{#model . #repositories . #internSpec} . 
					#layout: . { #FrameLayout . #fractions:offsets: . 0.5@0 corner: 1@1 . 0@0 corner: 0@0} 
					} .
			#vSpaceFill . #hSpaceFill
	
	}! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:41'!
order
	^ Order ifNil: [ Order := 1 ]! !

!MonticelloRepositoryBrowser class methodsFor: 'utils' stamp: 'StephaneDucasse 4/17/2012 18:42'!
order: anInteger
	Order := anInteger! !

!MonticelloRepositoryBrowser class methodsFor: 'spec' stamp: 'StephaneDucasse 4/17/2012 18:07'!
title

	^ 'Monticello Browser'! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:31'!
allRepositories

	^ MCRepositoryGroup default repositories! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:20'!
browseWorkingCopy
	| workingCopy |
	workingCopy := self workingCopy.
	workingCopy
		ifNotNil: [ 
			(MCSnapshotBrowser forSnapshot: workingCopy completeSnapshot)
				label: 'Snapshot Browser: ' , workingCopy packageName;
				show ]! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 19:11'!
defaultOrderingBlock

	^ (self orderSpecs at: self class order) value! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'StephaneDucasse 4/17/2012 18:06'!
initialExtent

	^ 600@200! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'SD 4/19/2012 16:13'!
initialize
	"Initialization code for MonticelloRepositoryBrowser"

	"so that when we tab we go from working copies to repositories"
	super initialize.
	order := self class order.
	self initializeWorkingCopies.
	self initializeRepositories.
	
	self focusOrder
		add: workingCopies;
		add: repositories! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'StephaneDucasse 4/17/2012 19:07'!
initializeRepositories
	repositories := self instantiate: ListComposableModel.
	repositories wrappingBlock: [ :item | item description ].
	repositories items: self allRepositories! !

!MonticelloRepositoryBrowser methodsFor: 'initialize' stamp: 'SD 4/19/2012 16:13'!
initializeWorkingCopies

	workingCopies := self instantiate: ListComposableModel.
	workingCopies sortingBlock: self defaultOrderingBlock.
	workingCopies wrappingBlock: [ :item | item description ].
	workingCopies whenSelectedItemChanges: 
			[ :item | repositories items: (self repositoriesOfWorkingCopy: item) ].
	workingCopies menu: [ :aMenu | self workingCopiesMenu: aMenu ]! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:21'!
newRepository
	| types index |
	types := MCRepository allConcreteSubclasses asArray.
	index := UIManager default chooseFrom: (types collect: [:ea | ea description])
				title: 'Repository type:'.
	^ index = 0 ifFalse: [(types at: index) morphicConfigure]! !

!MonticelloRepositoryBrowser methodsFor: 'actions' stamp: 'StephaneDucasse 4/19/2012 18:19'!
openRepository
	self repository ifNotNil: [:repos | repos morphicOpen: self workingCopy ]! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:49'!
order

	^ order! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'SD 4/19/2012 16:16'!
order: anInteger

	order := anInteger.
	self workingCopies sortingBlock: (self orderSpecs at: order) value.
	self order = 4 "dirty only"
		ifTrue: [self workingCopies filteringBlock: [:col | col select: #modified]]
		ifFalse: [self workingCopies resetFilteringBlock]. ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:35'!
orderSpecs
	^ {
		'Sort alphabetically' -> [ :a :b | a package name <= b package name ].
		'Sort dirty first' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ a needsSaving ] ].
		'Sort dirty last' -> [ :a :b | 
			a needsSaving = b needsSaving
				ifTrue: [ a package name <= b package name ]
				ifFalse: [ b needsSaving ] ].
		'Only dirty' -> [ :a :b | a package name <= b package name ]}! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:48'!
orderString: anIndex
	^ String streamContents: [ :stream |
		order = anIndex
			ifTrue: [ stream nextPutAll: '<yes>' ]
			ifFalse: [ stream nextPutAll: '<no>' ].
		stream nextPutAll: (self orderSpecs at: anIndex) key ]! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
repositories

	^ repositories! !

!MonticelloRepositoryBrowser methodsFor: 'private' stamp: 'StephaneDucasse 4/17/2012 18:20'!
repositoriesOfWorkingCopy: aWorkingCopy
	
	^ aWorkingCopy isNil
		ifFalse: [ aWorkingCopy repositoryGroup repositories]
		ifTrue: [ self allRepositories]	! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/17/2012 18:04'!
workingCopies

	^ workingCopies! !

!MonticelloRepositoryBrowser methodsFor: 'protocol' stamp: 'SD 4/19/2012 16:12'!
workingCopies: aCollection
	"Set the value of the list widget"
	
	workingCopies items: aCollection ! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/17/2012 18:46'!
workingCopiesFromMC
	^ (self orderSpecs size = order
		ifTrue: [ MCWorkingCopy allManagers select: [ :each | each modified ] ]
		ifFalse: [ MCWorkingCopy allManagers ])
			asSortedCollection: (self orderSpecs at: order) value.! !

!MonticelloRepositoryBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 4/19/2012 18:17'!
workingCopiesMenu: aMenu


	aMenu target: self;
		add: 'Browse working copy' action: #browseWorkingCopy.

	1 to: self orderSpecs size do: [ :index | 
		aMenu
			addUpdating: #orderString:
			target: self
			selector: #order:
			argumentList: {index} ].
	^ aMenu! !

!MonticelloRepositoryBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 18:20'!
workingCopy
	^ workingCopies selectedItem! !

ComposableModel subclass: #WorkingCopyToolBar
	instanceVariableNames: 'browseButton configButton packageButton sliceButton workingCopyHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!WorkingCopyToolBar commentStamp: '<historical>' prior: 0!
WorkingCopyToolBar new openWithSpec!

!WorkingCopyToolBar class methodsFor: 'specs' stamp: 'StephaneDucasse 4/19/2012 17:35'!
internSpec 

	^ {#Panel . 
			#useProportionalLayout .
			#add: . {{#model . #packageButton . #internSpec} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0@0 corner: 0.25@0 . 
											0@0 corner: 0@25 }} . 

#add: . {{#model . #configButton . #internSpec} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.25@0 corner: 0.50@0 . 
											0@0 corner: 0@25 }} . 
											
#add: . {{#model . #sliceButton . #internSpec} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.50@0 corner: 0.75@0 . 
											0@0 corner: 0@25 }} . 											

#add: . {{#model . #browseButton . #internSpec} .
						#layout: . {#FrameLayout  . #fractions:offsets: .  
											0.75@0 corner: 1@0 . 
											0@0 corner: 0@25 }} 	
		}! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:33'!
browseButton
	^ browseButton! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
configButton
	
	^ configButton! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 17:38'!
createBrowseButton
	browseButton := self instantiate: ButtonModel.
	browseButton
		state: false;
		enabled: false;
		label: 'Browse';
		help: 'Browse the working copy of the selected package';
		action: [ self browseWorkingCopy ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 17:38'!
createConfigButton
	configButton := self instantiate: ButtonModel.
	configButton
		state: false;
		label: '+Config';
		help: 'Add a new metacello configuration';
		action: [ self createConfiguration ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 17:11'!
createPackage

	|name|
	name := UIManager default request: 'Name of package:' translated.
	name isEmptyOrNil ifFalse:
		[ PackageInfo registerPackageName: name.
		MCWorkingCopy forPackage: (MCPackage new name: name).]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 17:39'!
createPackageButton
	packageButton := self instantiate: ButtonModel.
	packageButton
		state: false;
		label: '+Package';
		help: 'Add a new package and make it the working copy';
		action: [ self createPackage ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 17:54'!
createSliceButton
	sliceButton := self instantiate: ButtonModel.
	sliceButton
		state: false;
		label: '+Slice';
		help: 'Add a slice to cleaning and nicely propose a bug fix';
		action: [ self createSlice ]! !

!WorkingCopyToolBar methodsFor: 'initialize' stamp: 'StephaneDucasse 4/19/2012 16:57'!
initialize
	"Initialization code for WorkingCopyToolBar"

	super initialize.
	self createBrowseButton.
	self createConfigButton.
	self createPackageButton.
	self createSliceButton.
	workingCopyHolder := nil asValueHolder! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:32'!
packageButton

	^ packageButton! !

!WorkingCopyToolBar methodsFor: 'accessing' stamp: 'StephaneDucasse 4/19/2012 17:34'!
sliceButton
	
	^ sliceButton! !

AbstractTool subclass: #ChangeSorterModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterModel commentStamp: '<historical>' prior: 0!
A ChangeSorterModel is a model used by Change Sorter UIs for computation!

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
addPreambleTo: aChangeSet

	aChangeSet assurePreambleExists! !

!ChangeSorterModel methodsFor: 'environment' stamp: ''!
allChanges

	^ ChangeSet allChangeSets reverse! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildChangeSetDescriptionFor: changeSet
		
	^ changeSet
		ifNil: [ '' ] 
		ifNotNil: [ changeSet preambleString ifNil: ['']]! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildClassDescriptionFor: changeSet class: class
	| stream |

	stream := (String new: 100) writeStream.
		(changeSet classChangeAt: class name)
			do: [:each | 
				each = #remove
					ifTrue: [ stream nextPutAll: 'Entire class was removed.'; cr ].
				each = #addedThenRemoved
					ifTrue: [ stream nextPutAll: 'Class was added then removed.'; cr ].
				each = #rename
					ifTrue: [ stream nextPutAll: 'Class name was changed.'; cr ].
				each = #add
					ifTrue: [ stream nextPutAll: 'Class definition was added.'; cr ].
				each = #change
					ifTrue: [ stream nextPutAll: 'Class definition was changed.'; cr ].
				each = #reorganize
					ifTrue: [ stream nextPutAll: 'Class organization was changed.'; cr ].
				each = #comment 
					ifTrue: [ stream nextPutAll: 'New class comment.'; cr ]].
		^ stream contents! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff

	| changeType code |
	changeType := changeSet atSelector: selector class: class name.
	
	changeType == #remove
		ifTrue: [^ 'Method has been removed (see versions)'].
	changeType == #addedThenRemoved
		ifTrue: [^ 'Added then removed (see versions)']. 
	class
		ifNil: [^ 'Method was added, but cannot be found!!'].
	(class includesSelector: selector)
		ifFalse: [^ 'Method was added, but cannot be found!!'].
	code := class sourceCodeAt: selector.
	prettyPrint
		ifTrue: [ code := class prettyPrinterClass
							format: code
							in: class
							notifying: nil ].						
	showDiff
		ifTrue: [ code := self diffFromPriorSourceFor: code ].
		
	^ code asText makeSelectorBoldIn: class! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
copyAllChangesFrom: source to: destination

	destination assimilateAllChangesFoundIn: source! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
copyClass: aClass from: source to: destination

	destination absorbClass: aClass name from: source.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
copySelector: selector inClass: class from: source to: destination

	destination
		absorbMethod: selector 
		class: class 
		from:source! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
createNewSet

	^ ChangeSet newChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
fileOutClass: aClass from: aChangeSet
	"this is a hack!!!! makes a new change set, called the class name, adds author initials to try to make a unique change set name, files it out and removes it. kfr 16 june 2000"
	"Method copied from ChangeSorter"
	| aSet |
	"File out the selected class set."
     aSet := ChangeSet newChangeSet: aClass name.
	aSet ifNil:[ ^self ].
	aSet absorbClass: aClass name from: aChangeSet.
	aSet fileOut.
	ChangeSet removeChangeSet: aSet.! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
fileOutSelector: selector from: aClass
	
	aClass fileOutMethod: selector! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
findChangeSetIn: aCollectionOfChangeSets
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates nameList |
	self okToChange ifFalse: [^ self].
	pattern := UIManager default request: 'ChangeSet name or fragment?'.
	pattern isEmptyOrNil ifTrue: [^ self].
	nameList := aCollectionOfChangeSets collect: #name.
	candidates := aCollectionOfChangeSets select:
			[:c | (nameList includes: c name) and: 
				[c name includesSubstring: pattern caseSensitive: false]].
	candidates size = 0 ifTrue: [ ^ Beeper beep ].
	candidates size = 1 ifTrue: [ ^ candidates first ].
	index := UIManager default chooseFrom: (candidates collect: [:each | each name]).
	index = 0 ifFalse: [ ^ (candidates at: index) ].! !

!ChangeSorterModel methodsFor: 'message' stamp: ''!
forgetSelector: selector inClass: aClass fromChangeSet: aChangeSet

	aChangeSet
			removeSelectorChanges: selector 
			class: aClass! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removeChangeSet: aChangeSet prompting: doPrompt
	"Completely destroy my change set.  Check if it's OK first, and if doPrompt is true, get the user to confirm his intentions first."

	| message aName changeSetNumber msg |
	aName := aChangeSet name.
	aChangeSet okayToRemove ifFalse: [^ self]. "forms current changes for some project"
	(aChangeSet isEmpty or: [doPrompt not]) ifFalse:
		[message := 'Are you certain that you want to 
remove (destroy) the change set
named  "', aName, '" ?'.
		(self confirm: message) ifFalse: [^ self]].

	doPrompt ifTrue:
		[msg := aChangeSet hasPreamble
			ifTrue:
				[aChangeSet hasPostscript
					ifTrue:
						['a preamble and a postscript']
					ifFalse:
						['a preamble']]
			ifFalse:
				[aChangeSet hasPostscript
					ifTrue:
						['a postscript']
					ifFalse:
						['']].
		msg isEmpty ifFalse:
			[(self confirm: 
'Caution!!  This change set has
', msg, ' which will be
lost if you destroy the change set.
Do you really want to go ahead with this?') ifFalse: [^ self]]].

	"Go ahead and remove the change set"
	changeSetNumber := aChangeSet name initialIntegerOrNil.
	changeSetNumber ifNotNil: [SystemVersion current unregisterUpdate: changeSetNumber].
	ChangeSet removeChangeSet: aChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: ''!
removeClass: class from: changeSet

	changeSet removeClassChanges: class.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
removePostscriptFrom: aChange

	(aChange hasPostscript and: [ aChange postscriptHasDependents ]) ifTrue:
		[^ self inform:
'Cannot remove the postscript right
now because there is at least one
window open on that postscript.
Close that window and try again.'].

	aChange removePostscript.! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
rename: aChangeSet
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName := UIManager default request: 'New name for this change set'
						initialAnswer: aChangeSet name.
						
	(newName = aChangeSet name or: [newName isEmptyOrNil]) ifTrue:
			[ ^ Beeper beep ].

	(ChangeSet named: newName) ifNotNil:
			[ ^ UIManager default inform: 'Sorry that name is already used' ].

	aChangeSet name: newName.
	^ aChangeSet! !

!ChangeSorterModel methodsFor: 'text' stamp: ''!
setContentsOfChangeSet: changeSet forClass: class andSelector: selector prettyPrint: prettyPrint showDiff: showDiff 
	"return the source code that shows in the bottom pane"
	| strm changeType code |

	
	class
		ifNil: [
			"Only the change set is currently selected"
			^ self buildChangeSetDescriptionFor: changeSet ].
	selector isNil
		ifTrue: [ 
			"class is selected but not the selector"
			^ self buildClassDescriptionFor: changeSet class: class ]
		ifFalse: [
			"a class and a selector are selected"
			^ self buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff ]! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
setCurrentChangeSet: aChangeSet

	ChangeSet newChanges: aChangeSet! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
submerge: source into: destination
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	|   message |
	source == destination
		ifTrue: [ ^ false ].
	source isEmpty
		ifTrue: [ 
			self inform: 'Nothing to copy.  To remove,
simply choose "remove".'.
			^ false ].

	source okayToRemove ifFalse: [^ false].
	message := 'Please confirm:  copy all changes
in "', source name, '" into "', destination name, '"
and then destroy the change set
named "', source name, '"?'.
 
	(self confirm: message) ifFalse: [^ false].

	(source hasPreamble or: [source hasPostscript]) ifTrue:
		[(self confirm: 
'Caution!!  This change set has a preamble or
a postscript or both.  If you submerge it into
the other side, these will be lost.
Do you really want to go ahead with this?') ifFalse: [^ false]].

	self copyAllChangesFrom: source to: destination.
	self removeChangeSet: source prompting: false.
	^ true! !

!ChangeSorterModel methodsFor: 'change set' stamp: ''!
substractFrom: source to: destination

	source forgetAllChangesFoundIn: destination.! !

Object subclass: #ConfigurationGenerator
	instanceVariableNames: 'repository workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Monticello'!

!ConfigurationGenerator commentStamp: '<historical>' prior: 0!
Probably to be removed to use metacello toolbox!

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:00'!
addMetacelloBaseline
	| baselineNumber existingBaselines msg selectorName  addedPackages package stream packagePattern |
	
	"0 -- must have a repository selected"
	repository isNil 
		ifTrue: [ 
			UIManager default inform: 'Please select a repository and try again'. 
			^self ].
	"1 -- Selecting baseline name"
	existingBaselines := self baseLines. 
	
	existingBaselines size > 0  
		ifTrue: [msg := 'Current baselines:', String cr, (existingBaselines inject: '' into: [:sum :el | sum, el, String cr]), 'Enter a new baseline number']
		ifFalse: [msg := 'Enter a new baseline number ("-baseline" will be automatically added)'].
		
	baselineNumber := UIManager default request: msg initialAnswer: '1.0'.
	baselineNumber ifNil: [ ^ self ].
	
	"2 -- add package names"
	addedPackages := OrderedCollection new.
	packagePattern := UIManager default request: 'Please enter a pattern to filter package names' initialAnswer: '*'.
	[ | packageNames workingCopies |
	 packageNames := OrderedCollection new.
	workingCopies := OrderedCollection new.
	self workingCopies do: [:pkg | 
		((packagePattern match: pkg package name) and: [ (addedPackages includes: pkg package name) not ])
			ifTrue: [ 
				packageNames add: pkg package name.
				workingCopies add: pkg ]].
	 package := 
		UIManager default 
			chooseFrom: packageNames
			values: workingCopies
			title: 'Add dependent package (cancel to stop)'.
	 package ifNotNil: [addedPackages add: package package name ]
	] doWhileTrue: [ package notNil ].

	
	"3 -- Creating baseline"
	selectorName := baselineNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'baseline'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: baselineNumber.
	stream nextPutAll: '-baseline''>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: '''.

	stream nextPutAll: repository description.
	stream nextPutAll: '''.    
                "spec 
                        package: ''Example-Core'';
                        package: ''Example-Tests'' with: [ spec requires: ''Example-Core'' ]"
'.
	addedPackages 
		do: [:pName | stream nextPutAll: '			spec package: ''', pName, '''.', String cr].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'baselines'.
! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
baseLines 
	| existingBaselines |
	existingBaselines := self configurationClass methods select: [:cm | cm selector beginsWith: 'baseline'].
	existingBaselines := (existingBaselines collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	^ existingBaselines! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
browseConfiguration
	self configurationClass browse! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
configurationClass
	^ Smalltalk globals at: workingCopy package name asSymbol ! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createDevelopmentVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
	^ self createVersionForBlessing: #development! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createReleaseVersion
	self hasAnyBaseline 
		ifFalse: [ UIManager default inform: 'Please, define a baseline first'. ^ self ].
		
	^ self createVersionForBlessing: #release! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
createVersionForBlessing: blessingSelector
	"blessingSelector = #release or #development"
	 
	| existingVersions msg initialAnswer newVersionNumber selectorName stream dependentPackages mcWorkingCopy |
	existingVersions := self configurationClass methods select: [:cm | cm selector beginsWith: 'version'].
	existingVersions := (existingVersions collect: [:m | m pragmas first argumentAt: 1]) asSortedCollection.
	
	msg := ''.
	existingVersions size > 4
		ifTrue: [ 
			msg := 'Last 4 versions: ', 
			(existingVersions copyFrom: (existingVersions size - 4) to: existingVersions size)
				 asArray printString, String cr ].
	
	existingVersions size > 0
		ifTrue: [ initialAnswer := existingVersions last, '.1' ]
		ifFalse: [ initialAnswer := '1.0' ].
	
	newVersionNumber := UIManager default request: msg initialAnswer: initialAnswer.
	newVersionNumber ifNil: [ ^ self ].

	selectorName := newVersionNumber copyWithoutAll: '.-'.
	stream := WriteStream on: String new.
	stream nextPutAll: 'version'.
	stream nextPutAll: selectorName.
	stream nextPutAll: ': spec 
        <version: '''.
	stream nextPutAll: newVersionNumber.
	stream nextPutAll: ''' imports: #(''', self lastBaseLine,''')>

        spec for: #common do: [
                spec blessing: ',blessingSelector printString,'.
'.

	self dependentPackages 
		do: [:pName | 
				stream nextPutAll: '			spec package: ''', pName, ''' with: '''.
							
				mcWorkingCopy := (MCPackage named: pName) workingCopy.
				mcWorkingCopy needsSaving ifTrue: [ self inform: 'The configuration you want to save depends on the package ', pName, '. You first need to save this package in order to create the version'. ^ self ].
				stream nextPutAll: (mcWorkingCopy ancestry ancestors first name).
			
				stream nextPutAll: '''.', String cr ].
	stream nextPutAll: '                ].'.

	self configurationClass compile: stream contents classified: 'versions'.

! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
dependentPackages
	"Return the list of dependent packages for the last baseline"

	"This method must be rewritten. It is a shame..."
	
	| lastBaseLineName lastBaseLineMethod versionConstructor versionSpec possiblePackageNames packageInfos packageNames |
	lastBaseLineName := self lastBaseLine.

	packageNames := OrderedCollection new.
	(self configurationClass project version: lastBaseLineName)
		record loadDirective packageDirectivesDo: [:directive |
			packageNames add: directive file ].
		
	^ packageNames collect: [:p | 
		(p includes: $.)
			ifTrue: [ (p includes: $-)
						ifTrue: [ (p copyUpToLast: $-) ]
						ifFalse: [ (p copyUpTo: $.) ] ]
			ifFalse: [ p ]
		]

"	lastBaseLineMethod := (self configurationClass methods 
							select: [:cm | cm selector beginsWith: 'baseline'])
								select: [:cm | cm pragmas first arguments first = lastBaseLineName].
	lastBaseLineMethod := lastBaseLineMethod first.
"	
	"This does not work!! No idea why!!"
"	versionConstructor := (Smalltalk at: #MetacelloVersionConstructor) new.
	self configurationClass new perform: lastBaseLineMethod selector with: versionConstructor.
	versionSpec := (Smalltalk at: #MetacelloVersionSpec) new.
	versionConstructor root: versionSpec
"
	"This is probably the ugliest piece of code I ever wrote. There is really nothing to be proud of."
"	possiblePackageNames := 
		((lastBaseLineMethod literals select: [ :l | l class == ByteString ])
			reject: [:l | l beginsWith: 'http']).
	packageInfos := PackageInfo allPackages select: [ :pi | possiblePackageNames includes: pi packageName ].
"
	"packageInfos now contains the package that the lastest baseline depends on"
	"^ packageInfos collect: #packageName"

	! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
hasAnyBaseline 
	^ self baseLines notEmpty! !

!ConfigurationGenerator methodsFor: 'metacello' stamp: 'StephaneDucasse 4/19/2012 18:01'!
lastBaseLine
	^ self baseLines last! !
